VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00FFFFFF&
   Caption         =   "Vega Smart Plus Output Cycling Program"
   ClientHeight    =   6525
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4905
   LinkTopic       =   "Form1"
   ScaleHeight     =   6525
   ScaleWidth      =   4905
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox SelectCycle 
      Enabled         =   0   'False
      Height          =   315
      ItemData        =   "Cycler.frx":0000
      Left            =   2400
      List            =   "Cycler.frx":000A
      TabIndex        =   12
      Text            =   "Program 1"
      Top             =   4320
      Width           =   1455
   End
   Begin VB.CommandButton CloseCommunications 
      Caption         =   "Close Communications"
      Enabled         =   0   'False
      Height          =   375
      Left            =   1440
      TabIndex        =   11
      Top             =   3360
      Width           =   2055
   End
   Begin VB.CommandButton OpenCommunications 
      Caption         =   "Open Communications"
      Height          =   375
      Left            =   1440
      TabIndex        =   10
      Top             =   2760
      Width           =   2055
   End
   Begin VB.CommandButton Reset 
      Caption         =   "Reset"
      Enabled         =   0   'False
      Height          =   375
      Left            =   1920
      TabIndex        =   7
      Top             =   5400
      Width           =   1095
   End
   Begin VB.CommandButton Stop 
      Caption         =   "Stop"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2640
      TabIndex        =   6
      Top             =   4800
      Width           =   975
   End
   Begin VB.CommandButton Start 
      Caption         =   "Start"
      Enabled         =   0   'False
      Height          =   375
      Left            =   1320
      TabIndex        =   5
      Top             =   4800
      Width           =   975
   End
   Begin VB.ComboBox UnitIDSelect 
      Height          =   315
      ItemData        =   "Cycler.frx":0024
      Left            =   2400
      List            =   "Cycler.frx":0088
      TabIndex        =   3
      Text            =   "1"
      Top             =   2280
      Width           =   1455
   End
   Begin VB.ComboBox ComPortSelect 
      Height          =   315
      ItemData        =   "Cycler.frx":0103
      Left            =   2400
      List            =   "Cycler.frx":0119
      TabIndex        =   1
      Text            =   "com1"
      Top             =   1800
      Width           =   1455
   End
   Begin VB.Label Label4 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Select Cycling Program"
      Height          =   255
      Left            =   600
      TabIndex        =   13
      Top             =   4365
      Width           =   1695
   End
   Begin VB.Label CyclerLabel 
      Alignment       =   2  'Center
      BackColor       =   &H00FFFFFF&
      Caption         =   "Cycler Active"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   255
      Left            =   1560
      TabIndex        =   9
      Top             =   3960
      Visible         =   0   'False
      Width           =   2055
   End
   Begin VB.Label CommunicationLabel 
      Alignment       =   2  'Center
      BackColor       =   &H00FFFFFF&
      Caption         =   "Communication Active"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   255
      Left            =   1560
      TabIndex        =   8
      Top             =   1440
      Visible         =   0   'False
      Width           =   2055
   End
   Begin VB.Label Label3 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Unit ID Select"
      Height          =   255
      Left            =   1080
      TabIndex        =   4
      Top             =   2325
      Width           =   1215
   End
   Begin VB.Label Label2 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Serial Port Select"
      Height          =   255
      Left            =   1080
      TabIndex        =   2
      Top             =   1875
      Width           =   1335
   End
   Begin VB.Label Label1 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Output Cycling Program"
      BeginProperty Font 
         Name            =   "Impact"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   840
      Width           =   3615
   End
   Begin VB.Image Image2 
      Height          =   465
      Left            =   3240
      Picture         =   "Cycler.frx":0141
      Top             =   5880
      Width           =   1500
   End
   Begin VB.Image Image1 
      Height          =   675
      Left            =   120
      Picture         =   "Cycler.frx":088B
      Top             =   120
      Width           =   4500
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public xVega As Object
Public Result As String
Public Running As Integer


Private Sub CloseCommunications_Click()
Result = xVega.closeport

Form1.OpenCommunications.Enabled = True
Form1.CloseCommunications.Enabled = False
Form1.Start.Enabled = False
Form1.Stop.Enabled = False
Form1.ComPortSelect.Enabled = True
Form1.UnitIDSelect.Enabled = False
Form1.CommunicationLabel.Visible = False
Form1.Reset.Enabled = False
Form1.SelectCycle.Enabled = False
End Sub

Public Sub Form_Load()
Set xVega = CreateObject("Vegax.vega.1")
End Sub


Private Sub Form_Terminate()

Result = xVega.closeport
Set xVega = Nothing
End Sub



Private Sub OpenCommunications_Click()
Dim Port As String

Port = Form1.ComPortSelect.Text
Result = xVega.openport(Port)
If Result = "CMD_OK" Then
    Form1.OpenCommunications.Enabled = False
    Form1.CloseCommunications.Enabled = True
    Form1.ComPortSelect.Enabled = False
    Form1.UnitIDSelect.Enabled = True
    Form1.CommunicationLabel.Visible = True
    Form1.Start.Enabled = True
    Form1.Reset.Enabled = True
    Form1.SelectCycle.Enabled = True

Else
    MsgBox "Could not open Port"
End If

End Sub

Private Sub Reset_Click()
Form1.Start.Enabled = False
Form1.Stop.Enabled = True
Form1.CyclerLabel.Visible = True
Form1.Reset.Enabled = False
Form1.UnitIDSelect.Enabled = False
Form1.SelectCycle.Enabled = False
Form1.CloseCommunications.Enabled = False
Form1.Stop.Enabled = False

Dim UnitID As Integer
Dim ModulePresent(1 To 8) As Integer
Dim ModuleGood(1 To 8) As Integer
Dim ModuleType As Integer
Dim StrModuleType As String
Dim ModuleTypeText(1 To 8) As String
Dim scalefile As String
Dim LiveIOut As Integer
Dim LiveIOuta(1 To 8) As Double
Dim LiveVOut As Integer
Dim LiveVOuta(1 To 8) As Double
Dim VScale(1 To 8) As Double
Dim IScale(1 To 8) As Double
Dim VMax(1 To 8) As Double
Dim VMin(1 To 8) As Double
Dim OutState(1 To 8) As Integer
Dim VoltSet(1 To 8) As Integer
Dim StartDelay As Double
Dim StopDelay As Double
    
scalefile = App.Path & "\" & "scale.ini" 'sets location of scale.ini to same as executable
UnitID = Form1.UnitIDSelect.Text
Running = 1
Result = xVega.getpresentmodules(UnitID, ModulePresent) 'finds out how many modules (y) are present in the unit
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

y = 0
For x = 1 To 5
    If ModulePresent(x) = 1 Then
        y = y + 1 'counts present modules
    Else
    End If
Next

'gather information
For x = 1 To y 'loop for number of present modules
    Result = xVega.getmoduletype(UnitID, x, ModuleType) 'gets module type number for module x
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
    StrModuleType = "TYPE" & Trim(Str(ModuleType)) 'formats module type for use with INI file
    VScale(x) = GetFromINI(StrModuleType, "VoltageScaleFactor", scalefile) 'gets voltage scale factor for module x from INI file
    IScale(x) = GetFromINI(StrModuleType, "CurrentScaleFactor", scalefile) 'gets current scale factor for module x from INI file
    VMax(x) = GetFromINI(StrModuleType, "MaxVoltage", scalefile) 'gets maximum voltage for module x from INI file
    VMin(x) = GetFromINI(StrModuleType, "MinVoltage", scalefile) 'gets minimum voltage for module x from INI file
    ModuleTypeText(x) = GetFromINI(StrModuleType, "Type", scalefile) 'gets module type for module x from INI file
    Result = xVega.measureoutputvoltage(UnitID, x, LiveVOut) 'measure the output voltage of module x
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
    Result = xVega.measureoutputcurrent(UnitID, x, LiveIOut) 'measure the output current of module x
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
    LiveVOuta(x) = LiveVOut / VScale(x) 'scale output voltage
    LiveIOuta(x) = LiveIOut / IScale(x) 'scale output current
    Result = xVega.getmodulegoodstatusbyte(UnitID, ModuleGood) 'get module good signals
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

    'turn on all outputs and set to nominal voltage
    Result = xVega.setoutputstate(UnitID, x, 1)
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
    Result = xVega.setoutputvoltagesetpoint(UnitID, x, Round(((VMax(x) + VMin(x)) * 0.5 * VScale(x)), 0))
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
    
Next
GoTo Finish

ComError: 'run when there is a communication port error
MsgBox "Cannot open the port " & ComPort & ", check that it is not already in use"
GoTo Finish

NoResponse: 'run when there is a no response error
MsgBox "The Unit Does Not Respond, check cabling and that a unit of ID " & UnitID & " is present and operational on the port " & ComPort & "."
GoTo Finish

GeneralError: 'run when there is a CMD_ERROR
MsgBox "The Unit Returned CMD_ERROR"
GoTo Finish

Finish: 'run at the end of cycling to clean up
Form1.Start.Enabled = True
Form1.Stop.Enabled = False
Form1.CyclerLabel.Visible = False
Form1.Reset.Enabled = True
Form1.UnitIDSelect.Enabled = True
Form1.SelectCycle.Enabled = True
Form1.CloseCommunications.Enabled = True
Form1.Stop.Enabled = True

End Sub

Private Sub Start_Click()
Form1.Start.Enabled = False
Form1.Stop.Enabled = True
Form1.CyclerLabel.Visible = True
Form1.Reset.Enabled = False
Form1.UnitIDSelect.Enabled = False
Form1.SelectCycle.Enabled = False
Form1.CloseCommunications.Enabled = False

Dim UnitID As Integer
Dim ModulePresent(1 To 8) As Integer
Dim ModuleGood(1 To 8) As Integer
Dim ModuleType As Integer
Dim StrModuleType As String
Dim ModuleTypeText(1 To 8) As String
Dim scalefile As String
Dim LiveIOut As Integer
Dim LiveIOuta(1 To 8) As Double
Dim LiveVOut As Integer
Dim LiveVOuta(1 To 8) As Double
Dim VScale(1 To 8) As Double
Dim IScale(1 To 8) As Double
Dim VMax(1 To 8) As Double
Dim VMin(1 To 8) As Double
Dim OutState(1 To 8) As Integer
Dim VoltSet(1 To 8) As Integer
Dim StartDelay As Double
Dim StopDelay As Double
    
scalefile = App.Path & "\" & "scale.ini" 'sets location of scale.ini to same as executable
UnitID = Form1.UnitIDSelect.Text
Running = 1
Result = xVega.getpresentmodules(UnitID, ModulePresent) 'finds out how many modules (y) are present in the unit
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

y = 0
For x = 1 To 5
    If ModulePresent(x) = 1 Then
        y = y + 1 'counts present modules
    Else
    End If
Next

'gather information and display
For x = 1 To y 'loop for number of present modules
    Result = xVega.getmoduletype(UnitID, x, ModuleType) 'gets module type number for module x
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
    StrModuleType = "TYPE" & Trim(Str(ModuleType)) 'formats module type for use with INI file
    VScale(x) = GetFromINI(StrModuleType, "VoltageScaleFactor", scalefile) 'gets voltage scale factor for module x from INI file
    IScale(x) = GetFromINI(StrModuleType, "CurrentScaleFactor", scalefile) 'gets current scale factor for module x from INI file
    VMax(x) = GetFromINI(StrModuleType, "MaxVoltage", scalefile) 'gets maximum voltage for module x from INI file
    VMin(x) = GetFromINI(StrModuleType, "MinVoltage", scalefile) 'gets minimum voltage for module x from INI file
    ModuleTypeText(x) = GetFromINI(StrModuleType, "Type", scalefile) 'gets module type for module x from INI file
    Result = xVega.measureoutputvoltage(UnitID, x, LiveVOut) 'measure the output voltage of module x
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
    Result = xVega.measureoutputcurrent(UnitID, x, LiveIOut) 'measure the output current of module x
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
    LiveVOuta(x) = LiveVOut / VScale(x) 'scale output voltage
    LiveIOuta(x) = LiveIOut / IScale(x) 'scale output current
    Result = xVega.getmodulegoodstatusbyte(UnitID, ModuleGood) 'get module good signals
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Next

If Form1.SelectCycle.Text = "Program 1" Then GoTo Start1
If Form1.SelectCycle.Text = "Program 2" Then GoTo Start2
GoTo GeneralError

    
Dim Minimum As Integer
Dim Maximum As Integer
Dim Disabled As Integer
Dim Nominal As Integer
Dim Enabled As Integer

Start1: 'start of cycling code for program 1
    
'do the 14 events
    
'event 1 turn on all outputs
For z = 1 To y
    Result = xVega.setoutputstate(UnitID, z, 1)
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Next z

'below is the code to delay the cycle for 2 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 2
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 2 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop

'event 2 turn off all outputs
For z = 1 To y
    Result = xVega.setoutputstate(UnitID, z, 0)
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Next z

'below is the code to delay the cycle for 2 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 2
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 2 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop

'event 3 turn on module 4, if present
If y < 4 Then GoTo skip3
Result = xVega.setoutputstate(UnitID, 4, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 1.5 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 1.5
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 1.5 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
skip3:

'event 4 turn on module 3, if present
If y < 3 Then GoTo skip4
Result = xVega.setoutputstate(UnitID, 3, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 1.5 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 1.5
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 1.5 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
skip4:
    
'event 5 turn on module 2, if present
If y < 2 Then GoTo skip5
Result = xVega.setoutputstate(UnitID, 2, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 1.5 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 1.5
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 1.5 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
skip5:
    
'event 6 turn on module 1, if present
If y < 1 Then GoTo skip6
Result = xVega.setoutputstate(UnitID, 1, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 2 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 2
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 2 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
skip6:
    
'event 7 turn off all outputs
For z = 1 To y
    Result = xVega.setoutputstate(UnitID, z, 0)
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Next z

'below is the code to delay the cycle for 2 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 2
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 2 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
    
'event 8 turn on module 4, if present
If y < 4 Then GoTo skip8
Result = xVega.setoutputstate(UnitID, 4, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 1.5 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 1.5
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 1.5 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
skip8:

'event 9 turn on modules 2 and 3, if present
If y < 2 Then GoTo skip9
If y < 3 Then GoTo skip9a

Result = xVega.setoutputstate(UnitID, 2, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Result = xVega.setoutputstate(UnitID, 3, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
GoTo skip9b
skip9a:
Result = xVega.setoutputstate(UnitID, 2, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
skip9b:
'below is the code to delay the cycle for 1.5 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 1.5
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 1.5 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
skip9:

'event 10 turn on module 1, if present
If y < 1 Then GoTo skip10
Result = xVega.setoutputstate(UnitID, 1, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 2 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 2
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 2 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
skip10:

'event 11 turn off all outputs
For z = 1 To y
    Result = xVega.setoutputstate(UnitID, z, 0)
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Next z

'below is the code to delay the cycle for 2 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 2
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 2 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop

'event 12 turn on module 1, if present
If y < 1 Then GoTo skip12
Result = xVega.setoutputstate(UnitID, 1, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 1.5 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 1.5
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 1.5 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
skip12:

'event 13 turn on modules 2, 3 and 4, if present
If y < 2 Then GoTo skip13
If y < 3 Then GoTo skip13a
If y < 4 Then GoTo skip13b

Result = xVega.setoutputstate(UnitID, 2, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Result = xVega.setoutputstate(UnitID, 3, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Result = xVega.setoutputstate(UnitID, 4, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
GoTo skip13c
skip13a:
Result = xVega.setoutputstate(UnitID, 2, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Result = xVega.setoutputstate(UnitID, 3, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
GoTo skip13c
skip13b:
Result = xVega.setoutputstate(UnitID, 2, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
skip13c:
'below is the code to delay the cycle for 2 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 2
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 2 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
skip13:

'event 14 turn off all outputs
For z = 1 To y
    Result = xVega.setoutputstate(UnitID, z, 0)
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Next z

'below is the code to delay the cycle for 2 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 2
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 2 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop

GoTo Start1



Start2:

'do the 10 events

'event 1 turn off all outputs
For z = 1 To y
    Result = xVega.setoutputstate(UnitID, z, 0)
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Next z

'below is the code to delay the cycle for 2 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 2
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 2 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop

'event 2 turn on module 4, if present
If y < 4 Then GoTo p2skip2
Result = xVega.setoutputstate(UnitID, 4, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 1.5 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 1.5
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 1.5 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
p2skip2:

'event 3 turn on module 3, set to minimum Vout if present
If y < 3 Then GoTo p2skip3
Result = xVega.setoutputvoltagesetpoint(UnitID, 3, Round((VMin(3) * VScale(3)), 0))
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Result = xVega.setoutputstate(UnitID, 3, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 1.5 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 1.5
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 1.5 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
p2skip3:

'event 4 turn on module 2, set to minimum Vout if present
If y < 2 Then GoTo p2skip4
Result = xVega.setoutputvoltagesetpoint(UnitID, 2, Round((VMin(2) * VScale(2)), 0))
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Result = xVega.setoutputstate(UnitID, 2, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 1.5 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 1.5
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 1.5 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
p2skip4:

'event 5 turn on module 1, if present
If y < 1 Then GoTo p2skip5
Result = xVega.setoutputstate(UnitID, 1, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 2 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 2
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 2 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
p2skip5:

'event 6 turn off all outputs
For z = 1 To y
    Result = xVega.setoutputstate(UnitID, z, 0)
    If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Next z

'below is the code to delay the cycle for 2 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 2
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 2 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop

'event 7 turn on module 4, if present
If y < 4 Then GoTo p2skip7
Result = xVega.setoutputstate(UnitID, 4, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 1.5 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 1.5
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 1.5 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
p2skip7:

'event 8 turn on module 3, set to maximum Vout if present
If y < 3 Then GoTo p2skip8
Result = xVega.setoutputvoltagesetpoint(UnitID, 3, Round((VMax(3) * VScale(3)), 0))
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Result = xVega.setoutputstate(UnitID, 3, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 1.5 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 1.5
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 1.5 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
p2skip8:

'event 9 turn on module 2, set to maximum Vout if present
If y < 2 Then GoTo p2skip9
Result = xVega.setoutputvoltagesetpoint(UnitID, 2, Round((VMax(2) * VScale(2)), 0))
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling
Result = xVega.setoutputstate(UnitID, 2, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 1.5 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 1.5
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 1.5 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
p2skip9:

'event 10 turn on module 1, if present
If y < 1 Then GoTo p2skip10
Result = xVega.setoutputstate(UnitID, 1, 1)
If Result = "CMD_ERROR" Then GoTo GeneralError 'Error handling

'below is the code to delay the cycle for 2 second
StartDelay = Timer   ' Set start time to now
StopDelay = StartDelay + 2
If StopDelay > 86400 Then StopDelay = StopDelay - 86400
Do While Timer < StopDelay 'wait for 2 seconds
    DoEvents    ' Yield to other processes while waiting
    If Running = 0 Then GoTo Finish 'stop logging if the stop button is pressed
Loop
p2skip10:

GoTo Start2

    
ComError: 'run when there is a communication port error
MsgBox "Cannot open the port " & ComPort & ", check that it is not already in use"
GoTo Finish

NoResponse: 'run when there is a no response error
MsgBox "The Unit Does Not Respond, check cabling and that a unit of ID " & UnitID & " is present and operational on the port " & ComPort & "."
GoTo Finish

GeneralError: 'run when there is a CMD_ERROR
MsgBox "The Unit Returned CMD_ERROR"
GoTo Finish

Finish: 'run at the end of cycling to clean up
Form1.Start.Enabled = True
Form1.Stop.Enabled = False
Form1.CyclerLabel.Visible = False
Form1.Reset.Enabled = True
Form1.UnitIDSelect.Enabled = True
Form1.SelectCycle.Enabled = True
Form1.CloseCommunications.Enabled = True

End Sub

Private Sub Stop_Click()
Running = 0
End Sub
