VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form Form1 
   Caption         =   "Vega SmartPlus HEX Communicator"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4605
   Icon            =   "terminal.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4605
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Result 
      BackColor       =   &H80000004&
      Enabled         =   0   'False
      Height          =   285
      Left            =   120
      TabIndex        =   9
      Top             =   1920
      Visible         =   0   'False
      Width           =   4335
   End
   Begin VB.CheckBox CheckCRC 
      Caption         =   "Add CRC byte, and check CRC of reply."
      Enabled         =   0   'False
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   1320
      Width           =   3255
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   3360
      Top             =   240
   End
   Begin VB.TextBox TextReceive 
      Height          =   285
      Left            =   120
      TabIndex        =   5
      Top             =   2640
      Width           =   4335
   End
   Begin VB.CommandButton SendButton 
      Caption         =   "Send"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3600
      TabIndex        =   4
      Top             =   1320
      Width           =   855
   End
   Begin VB.TextBox TextSend 
      Height          =   285
      Left            =   120
      TabIndex        =   3
      Top             =   960
      Width           =   4335
   End
   Begin VB.CommandButton ClosePortButton 
      Caption         =   "Close Port"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2160
      TabIndex        =   2
      Top             =   240
      Width           =   1095
   End
   Begin VB.ComboBox ComboPort 
      Height          =   315
      ItemData        =   "terminal.frx":030A
      Left            =   120
      List            =   "terminal.frx":0326
      TabIndex        =   1
      Text            =   "1"
      Top             =   240
      Width           =   615
   End
   Begin VB.CommandButton OpenPortButton 
      Caption         =   "Open Port"
      Height          =   375
      Left            =   840
      TabIndex        =   0
      Top             =   240
      Width           =   1095
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   4080
      Top             =   120
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      InBufferSize    =   512
      OutBufferSize   =   64
   End
   Begin VB.Shape CRCOKIndicator 
      FillColor       =   &H00C0C0C0&
      FillStyle       =   0  'Solid
      Height          =   135
      Left            =   3840
      Shape           =   3  'Circle
      Top             =   2300
      Visible         =   0   'False
      Width           =   135
   End
   Begin VB.Label Label4 
      Caption         =   "Received CRC OK"
      Height          =   255
      Left            =   2400
      TabIndex        =   11
      Top             =   2280
      Visible         =   0   'False
      Width           =   1335
   End
   Begin VB.Label Label3 
      Caption         =   "Message with CRC Added"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   1680
      Visible         =   0   'False
      Width           =   2055
   End
   Begin VB.Label Label2 
      Caption         =   "Recieved:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   2280
      Width           =   1815
   End
   Begin VB.Label Label1 
      Caption         =   "Send:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   720
      Width           =   3255
   End
   Begin VB.Shape PortOpenIndicator 
      FillColor       =   &H000000FF&
      FillStyle       =   0  'Solid
      Height          =   135
      Index           =   0
      Left            =   3840
      Shape           =   3  'Circle
      Top             =   360
      Width           =   135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public T As Long

Private Sub CheckCRC_Click()
If CheckCRC.Value = 1 Then
    Label4.Visible = True
    CRCOKIndicator.Visible = True
    Label3.Visible = True
    Result.Visible = True
Else
    Label4.Visible = False
    CRCOKIndicator.Visible = False
    Label3.Visible = False
    Result.Visible = False
End If

End Sub

Private Sub ClosePortButton_Click()
' This Subroutine closes the com port and enables /disables appropriate controls

MSComm1.PortOpen = False
ClosePortButton.Enabled = False
OpenPortButton.Enabled = True
ComboPort.Enabled = True
SendButton.Enabled = False
CheckCRC.Enabled = False
'set the port indicator to red
PortOpenIndicator(0).FillColor = &HFF&

End Sub


Private Sub Form_Terminate()
' This subroutine closes the com port if the program is terminated
On Error Resume Next

MSComm1.PortOpen = False

End Sub

Private Sub Form_Unload(Cancel As Integer)
' This subroutine closes the com port if the program is closed
On Error Resume Next
MSComm1.PortOpen = False

End Sub

Private Sub OpenPortButton_Click()
' This subroutine opens the com port and sets the controls approprately
MSComm1.Handshaking = comNone
MSComm1.Settings = "9600,n,8,1"
MSComm1.CommPort = ComboPort.Text
MSComm1.PortOpen = True
ClosePortButton.Enabled = True
OpenPortButton.Enabled = False
SendButton.Enabled = True
ComboPort.Enabled = False
CheckCRC.Enabled = True
' Set the com port indicator to green
PortOpenIndicator(0).FillColor = &HFF00&

End Sub

Private Sub SendButton_Click()
'This subroutine sends the data to the port and then reads back the response.
Dim Length As Integer
Dim TempChar As String
Dim DecChar As Integer
Dim SendString As String
Dim X As Integer
Dim TempInput As String
Dim TempInputChar As String
Dim TempCRC As String
Dim CharString As String
Dim OldCRC As Integer
Dim Char As Integer
Dim FinalCRC As String
Dim WaitTimer As Long

'clear the recieve textbox
TextReceive.Text = ""
'If the CRC check is selected we need to add a CRC byte to the message
If CheckCRC Then

    If TextSend.Text = "" Then
        MsgBox "Enter a Message First", vbCritical, "Error"
        Exit Sub
    Else
        TextSend.Text = UCase(TextSend.Text)
    End If

    'to calculate CRC first need number bytes of message
    Length = Len(TextSend.Text)
    'The CRC is calculated by passing the first and second byte of the message through
    'the CRC function, then passing the result with the next byte through the CRC
    'function and repeating for each byte of the message, then passing the result with
    'zero through the function.
    TempCRC = Mid(TextSend.Text, 1, 2)
    OldCRC = CDbl("&h" & TempCRC)
    For X = 3 To Length Step 2
        CharString = Mid(TextSend.Text, X, 2)
        Char = CDbl("&h" & CharString)
        OldCRC = CRC(OldCRC, Char)
    Next X
    OldCRC = CRC(OldCRC, 0)
    'Now the CRC can be converted to HEX
    FinalCRC = Hex(OldCRC)
    'Add a leading zero if required.
    If Len(FinalCRC) = 1 Then FinalCRC = "0" & FinalCRC
    'Pass the message and the CRC to the result text box.
    Result.Text = TextSend.Text & FinalCRC
Else
    'crc already added, just transfer to result
    Result.Text = TextSend.Text
End If

'need to convert text into correct format to send
'first calculate the length of the message
Length = Len(Result.Text)
'for RS-485 communications the RTS (Request To Send) pin is set high for the duration
'of the message being sent, this duration must be calculated.  At 9600 baud it takes
'approx 0.84mS per byte. The Timer interval is set to the value of length.
Timer1.Interval = Length

' Now need to calculate the actual string to send in the correct format, each byte to
'send is represented by a two digit HEX number, thus the input string must be split
'into two digit chunks, each of these are then converted to decimal and then the the
'character represented by this code is added onto the SendString.
For X = 1 To Length Step 2
    TempChar = Mid(Result.Text, X, 2)
    DecChar = Val("&h" & TempChar)
    SendString = SendString & Chr(DecChar)
Next X
' For RS-485 we need to enable the RTS to set the port to transmit, in RS-232 this has
' no effect for the Vega SmartPlus
MSComm1.RTSEnable = True
' Now we can transmit the SendString plus a Carriage Return
MSComm1.Output = SendString & vbCr
' Now for RS-485 we need to wait before disabling RTS
'
X = T
'enable the timer
Timer1.Enabled = True
'Wait until the timer has incremented (this will happen after the timer interval has expired)
Do While X = T
DoEvents
Loop
'Now we can disable the RTS, so the RS-485 port can recieve the response.
MSComm1.RTSEnable = False
'We can switch off the timer and reset it now also.
Timer1.Enabled = False
T = 0

'Now we need to wait for a response
WaitTimer = Timer
Do
    DoEvents
    'check that the com port has not been closed, if it has we can stop waiting.
    If MSComm1.PortOpen = False Then Exit Sub
    'read the input from the com port
    TempInput = MSComm1.Input
    'if it contains a message we then need to convert it back into HEX valuse to display
    If TempInput <> "" Then
        'Calculate length of message
        Length = Len(TempInput)
        'Repeat converstion for each byte in message
        For X = 1 To Length
            'Extract the Xth byte in the message, calculate it's ASCII code and
            ' then convert this to HEX
            TempInputChar = Hex(Asc(Mid(TempInput, X, 1)))
            ' if this is a single character add a leading zero
            If Len(TempInputChar) = 1 Then
                TempInputChar = "0" & TempInputChar
            End If
            'Add this character to the receive text.
            TextReceive.Text = TextReceive.Text & TempInputChar
        Next X
    End If
'Keep on waiting for the message until at least 1 byte has been recieved.
Loop Until Len(TextReceive.Text) > 2 Or Timer > WaitTimer + 2

If TextReceive.Text = "" Then
    CRCOKIndicator.FillColor = &HC0C0C0
    MsgBox "No Response", vbCritical, "Error"
    Exit Sub
End If

'Now if the CRC check is selected we need to check that the CRC byte is correct.
If CheckCRC Then
    'First we need to know the message length, excluding the CRC
    Length = Len(TextReceive.Text) - 2
    'Now we find the first byte of the message
    TempCRC = Mid(TextReceive.Text, 1, 2)
    'Now we put the decimal value of this into OldCRC
    OldCRC = CDbl("&h" & TempCRC)
    'Now we need pass the result with each successive byte through the CRC function
    For X = 3 To Length Step 2
        CharString = Mid(TextReceive.Text, X, 2)
        Char = CDbl("&h" & CharString)
        OldCRC = CRC(OldCRC, Char)
    Next X
    'finally we pass this with 0 through the CRC function
    OldCRC = CRC(OldCRC, 0)
    'we can now convert the result to HEX
    FinalCRC = Hex(OldCRC)
    'Add a leading zero if required
    If Len(FinalCRC) = 1 Then FinalCRC = "0" & FinalCRC
    'Now we have the final CRC, this should be the same as the final byte in the message
    If FinalCRC = Mid(TextReceive.Text, Length + 1, 2) Then
        'If it is the same make the indicator green
        CRCOKIndicator.FillColor = &HFF00&
    Else
        'If not make it red, an error has occured
        CRCOKIndicator.FillColor = &HFF&
    End If
Else
    'if CRC not checked make indicor turn off
    CRCOKIndicator.FillColor = &HC0C0C0

End If

End Sub

Private Sub Timer1_Timer()
'For every timer interval increment T, this is used in transmitting data, see the send sub.
T = T + 1

End Sub

Public Function CRC(OldCRC As Integer, ByVal Char As Integer) As Integer

Dim n As Integer

CRC = OldCRC

For n = 0 To 7
    CRC = CRC * 2
    Char = Char * 2
    If ((Char And 256) = 256) Then
        CRC = CRC + 1
    End If
    If ((CRC And 256) = 256) Then
        CRC = CRC Xor 7
    End If
    CRC = CRC And 255
    Char = Char And 255
Next

End Function

